// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "SubSceneController.hpp"

using namespace Dawn;

SubSceneController::SubSceneController(SceneItem *i)  : SceneItemComponent(i) {

}

void SubSceneController::onStart() {
  auto myScene = this->getScene();

  useEventLegacy([&]{
    if(!this->onlyUpdateUnpaused) return;
    if(this->subScene == nullptr) return;
    this->subScene->update();
  }, myScene->eventSceneUnpausedUpdate);

  useEventLegacy([&]{
    if(this->onlyUpdateUnpaused) return;
    if(this->subScene == nullptr) return;
    this->subScene->update();
  }, myScene->eventSceneUpdate);
}